/*
 * THC.c
 *
 * Created: 16.12.2012 08:30:48
 *  Author: Malte Knaust
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>
#include "lcd-routines.h"
#include "THC.h"
#include "debounce.h"
#include <avr/delay.h>
#include <avr/io.h>
#define F_CPU 8000000
#include <util/delay.h>
#include <avr/eeprom.h>

char menue_nr;
unsigned char c_down; 
unsigned char c_up;
int voltage_soll;
int voltage_ist;
int hysterese;
int arc_soll;
int arc_ist;


int hystereseeep;
int arc_solleep;
int eeFoohysterese EEMEM;
int eeFooarc_soll EEMEM;


int main(void)

{	
	//Ausgnge
	DDRB |= ( 1 << PB1 )|( 1 << PB2 )|( 1 << PB5 )|( 1 << PB6 );
	DDRC |= ( 1 << PC5 );
	
		//Eingnge
	DDRB  &= ~(1<<PB7)|(1<<PB3)|(1<<PB4);
	DDRC  &= ~(1<<PC3);
	
	
	// Pull Ups
	PORTC |= ( 1 << PC3 );
	PORTB |= ( 1 << PB7 )|( 1 << PB3 )|( 1 << PB4 );
	
	
	//Initialisierung
	
	ARC_OK_OFF;		
	UP_OFF;
	DOWN_OFF;
	Torch_Rel_OFF;
	D4_OFF;
	
			sei();
 			ADC_Init();
			lcd_init();
			menue_nr = 1;
			
					
					set_cursor(0,1);
					lcd_string( "MUCK Solutions" );		
					set_cursor(0,3);
					lcd_string( "THC Version 0.1" );	
					_delay_ms(2000);
					lcd_clear();
					lcd_menue(1);		
					
					
					eeprom_read_block(&hysterese,&eeFoohysterese,sizeof(int));
					eeprom_read_block(&arc_soll,&eeFooarc_soll,sizeof(int));
					
							
	
    while(1)
    {	
		voltage_soll = 500 + ((POTI_ADC*10)/8);
		voltage_ist =  (VOLTAGE_ADC*10)/(4.3);
		arc_ist = CURRENT_ADC/8;
		
		
		if (voltage_ist >= 500 && voltage_ist <= 1500)
		{
		
				
		if ( voltage_ist > (voltage_soll + (hysterese/2)))
		{	UP_OFF;
			DOWN_ON;
			c_down = 1;
			
			if (menue_nr == 1)
			{
					set_cursor(7,4);
					lcd_string( "-DOWN-" );	
			}
			
		}
		
		else {DOWN_OFF; c_down= 0;}
			
		if ( voltage_ist < (voltage_soll - (hysterese/2)))
		{	DOWN_OFF;
			UP_ON;
			c_up = 1;
			
			if (menue_nr == 1)
			{
					set_cursor(7,4);
					lcd_string( "--UP--" );	
			}
			
		}else{UP_OFF; c_up = 0;
			
			}
		
		if ((menue_nr == 1) && (c_up == 0) && (c_down == 0))
			{
					set_cursor(7,4);
					lcd_string( "--OK--" );	
			}
	
		
		
		}
		
		else
		{	UP_OFF;
			DOWN_OFF;
			
			if (menue_nr == 1)
			{
				
				    if (voltage_ist>=1700)
				    {
						set_cursor(7,4);
					    lcd_string( "-FAIL-" );
				    } 
				    else
				    {				    
					set_cursor(7,4);
					lcd_string( "------" );	
					}					
			}
		}		
		
		
		 if (button1())
		 {   lcd_clear();
			 menue_nr++;
			 if (menue_nr >= 4){menue_nr=1;}
				
				 	
		 }
				
		lcd_menue(menue_nr);
		
				eeprom_read_block(&arc_solleep,&eeFooarc_soll,sizeof( int));
				if(arc_soll != arc_solleep)
				{
					eeprom_write_block(&arc_soll,&eeFooarc_soll,sizeof( int));
				}
			
				eeprom_read_block(&hystereseeep,&eeFoohysterese,sizeof( int));
				if(hysterese != hystereseeep)
				{
					eeprom_write_block(&hysterese,&eeFoohysterese,sizeof( int));
				}
		            
		
		 
				
		
		
			
			
        //TODO:: Please write your application code 
    }
}